!	----------------------------------------------------------------------
!	File name: Globals.f90
!
!	Defines global variables.
!	----------------------------------------------------------------------


module Globals


	implicit none

	save


	!	convergence check

	real(8), parameter:: tol_value = 1.0D-4, tol_wage = 1.0D-4, tol_measure = 1.0D-8
	real(8), parameter:: sfac_wage = 0.5D0
	real(8):: err_value, err_W, err_U, err_J, err_wage, err_measure


	!	model parameters to be read

	real(8):: irate, alpha, bta, gama, lambda, Prod, UI, B_leisure, kappa, match_scale, match_pow, bta_J


	!	auxiliary variables
	
	real(8):: income, util_leisure
	

	!	theta, matching probabilities

	real(8):: theta, pth, qth, qth_fe, theta_fe


	!	grids for individual asset holdings

	integer, parameter:: na = 41, dna = 2001
	real(8):: agrid(na), step_a, amin, amax
	real(8):: dagrid(dna)
	

	!	wages

	real(8):: Wage(na)


	!	value functions

	real(8):: W(na), U(na), J(na), DJ(dna), VM


	!	measures

	real(8):: mu(dna), phi(dna)


	!	worker's asset and consumption decision rules

	real(8):: AE(na), AU(na), CE(na), CU(na)
	

	!	firm's vacancy decision rule

	real(8):: vac


	!	number of individuals in simulation

	real(8):: ave_asset, std_asset


	!	indexing

	integer:: ia, iter_value, iter_wage, iter_theta, iter_measure


	!	timer

	character(10):: startdate, finishdate
	character(10):: starttime, finishtime

	
end module
