clear all;
clc;

model = 1;

switch model 
case 1  
    cd ..\Fortran\AX_SS\Output\Benchmark
case 2
    cd ..\Fortran\AX_SS\Output\HighVolatility
end

trunc=0.99;

load phihat.txt;
load EmaxJG.txt;

%   compute vacancy posting cost ensuring the equilibrum theta to be 1

load agrid.txt;
load dagrid.txt;
load W.txt;
load U.txt;
load J.txt;
load wage.txt;
load cutoff_asset.txt;
load mu.txt;
load phi.txt;
load xgrid.txt;
load prX.txt;


cd ..\..\..\..\Matlab;


mu = mu(:,2:end);
mu_a = sum(mu,2);
mu_x = sum(mu,1);
phi = phi(:,2);
measure= sum(phi) + sum(mu_a)

mu = mu/measure;
mu_a  = mu_a/measure;
mu_x = mu_x/measure;
phi= phi/measure;

nx=length(xgrid);
na=length(agrid);
dna=length(dagrid);
mid_x = (nx+1)/2;

NN=dna;
dmm=dna;
cmu=mu_a;
for i=2:dna
    cmu(i) = mu_a(i)+ phi(i) + cmu(i-1);
end


for j=1:dna;    
    if cmu(j) <= trunc;
    dNN=j;  AA=dagrid(j);
    elseif cmu(j) > trunc;
    end
end

for j=1:na
    if agrid(j)<=AA
    NN=j;
    elseif agrid(j)>AA
    end
end
dNN
NN
    
W_conv = W(:,2:end);
U_conv = U(:,2:end);
J_conv = J(:,2:end);
wages_conv = wage(:,2:end);


Upp = spline(agrid, U_conv);
U_ = ppval(Upp, dagrid);


for i =1:nx
   Wpp(:,i) = spline(agrid, W_conv(:,i));
   Jpp(:,i) = spline(agrid, J_conv(:,i));
   wagepp(:,i) = spline(agrid, wages_conv(:,i));
end

for i=1:nx
    W_(:,i) = ppval(Wpp(:,i), dagrid);
    J_(:,i) = ppval(Jpp(:,i), dagrid);
    wage_(:,i) = ppval(wagepp(:,i), dagrid);
end


for i=1:nx
 if  cutoff_asset(i) > dna;
     cutoff_asset(i) = dna;
 end
end

for i=1:nx
    cutoff_a(i) = dagrid(cutoff_asset(i));
end

for i=1:nx;
    WU(:,i) = W_conv(:,i) - U_conv;
end


dna=size(mu_a);
nstep = 501;

max1= max(dagrid); min1 = min(dagrid);

step1 = ( max1 - min1 ) / (nstep-1);

mutil = zeros(nstep,2);
phitil = zeros(nstep,2);

for j=1:nstep
     ss1=0; ss2=0;
    mutil(j,1) = min1+(j+j-1)/2*step1;
    phitil(j,1)= min1+(j+j-1)/2*step1;
 for i = 1:dna
    if min1+(j-1)*step1<=dagrid(i) & dagrid(i) < min1+j*step1;
        ss1 = ss1+mu_a(i);
        ss2 = ss2+phi(i);
    end
 end
       mutil(j,2) = ss1;
       phitil(j,2) = ss2;
end


switch model 
case 1  
    figure(1)
    subplot(221), plot(agrid(1:NN),wage(1:NN,mid_x-1:mid_x+1),'linewidth',2)
    title('Panel A: Wages','FontSize',12)
    xlabel(' assets ','FontSize',12)
    ylabel('wages','FontSize',13)
    legend('x=0.87','x=1','x=1.18')
    subplot(223), plot(agrid(1:NN),WU(1:NN,mid_x-1:mid_x+1),'linewidth',2)
    title('Panel B: Employment vs. Unemployment Values','FontSize',12)
    xlabel('assets','FontSize',12)
    ylabel('W - U','FontSize',13)
    legend('x=0.87','x=1','x=1.18')
    subplot(224), plot(agrid(1:NN),J(1:NN,mid_x-1:mid_x+1),'linewidth',2)
    title('Panel C: Matched Firm Value','FontSize',12)
    xlabel('assets','FontSize',13)
    ylabel(' J ','FontSize',13)
    legend('x=0.87','x=1','x=1.18')
    print Fig1 -depsc

    figure(2)
    subplot(211), plot(dagrid(1:dNN),mu_a(1:dNN)/sum(mu_a),'b-',dagrid(1:dNN),phi(1:dNN)/sum(phi),'r-.','linewidth',2)
    xlabel('asset','FontSize',12)
    title('Panel A: Asset Distributions for Employed and Unemployed','FontSize',12)
    legend('Employed','Unemployed','FontSize',12)
    subplot(212), plot(cutoff_a(mid_x-7:mid_x+4),xgrid(mid_x-7:mid_x+4),'o-','linewidth',2)
    title('Panel B: Worker Assets and Reservation Match Productivity','FontSize',12)
    xlabel('asset','FontSize',12)
    ylabel('productivity','FontSize',12)
    legend('x*(a)')
    print Fig2 -depsc
    
case 2
        
    figure(4)
    subplot(211), plot(dagrid(1:dNN),mu_a(1:dNN)/sum(mu_a),'b-',dagrid(1:dNN),phi(1:dNN)/sum(phi),'r-.','linewidth',2)
    xlabel('asset','FontSize',12)
    title('Panel A: Asset Distributions for Employed and Unemployed','FontSize',12)
    legend('Employed','Unemployed','FontSize',12)
    subplot(212), plot(cutoff_a(mid_x-7:mid_x+4),xgrid(mid_x-7:mid_x+4),'o-','linewidth',2)
    title('Panel B: Worker Assets and Reservation Match Productivity','FontSize',12)
    xlabel('asset','FontSize',12)
    ylabel('productivity','FontSize',12)
    legend('x*(a)')
    print Fig4 -depsc
    
end

