clear all;
clc;

nstep=9;

cd ..\Fortran\AX_SS\Output


%==========================================================
%   Benchmark Economy
%==========================================================

cd Benchmark

load agrid.txt;
load dagrid.txt;
load cutoff_asset.txt;
load cutoff_xprod.txt;
load mu.txt;
load phi.txt;
load xgrid.txt;
load wage.txt

cd ..

xgrid = log(xgrid);
wage(:,2:end) = log(wage(:,2:end));

mu = mu(:,2:end)/10^10;
phi = phi(:,2)/10^10;
mu_a = sum(mu,2);
mu_x = sum(mu,1);

[na,nx] = size(mu);
mid_x = (nx+1)/2;

wages_conv = wage(:,2:end);
for i =1:nx
   wagepp(:,i) = spline(agrid, wages_conv(:,i));
end
for i=1:nx
    wage_(:,i) = ppval(wagepp(:,i), dagrid);
end

mutil = zeros(na,7);

k=1;
for i=1:na;
    a=dagrid(i);
    xj=cutoff_xprod(i);
    for j=xj:nx;
            xtil= xgrid(j) - xgrid(xj);
            wtil= wage_(i,j) - wage_(i,xj);
            mutil(k,1)=xtil;
            mutil(k,2)=xgrid(j);
            mutil(k,3)=xgrid(xj);
            mutil(k,4)=wtil;
            mutil(k,5)=wage_(i,j);
            mutil(k,6)=wage_(i,xj);
            mutil(k,7)=mu(i,j);
            k=k+1;
    end
end

ss=sum(mutil(:,end))

mutil(:,end) = mutil(:,end)/sum(mutil(:,end));
%mutilb=mutil;

[m n] = size(mutil);
for j=1:n-1
avg(j) = mutil(:,j)'*mutil(:,end);
SD(j) = ( (( mutil(:,j)-avg(j)).^2)'*mutil(:,end) )^.5;
end
for j=1:n-1
 for k=j:n-1
    cor_(j,k) = ( ( (mutil(:,j)-avg(j)).*(mutil(:,k)-avg(k)) )'*mutil(:,end) ) / ( SD(j)*SD(k) );
 end
end

disp('Benchmark')
disp('  ln x-ln x*    ln x    ln x*    ln w-ln w*    ln w    ln w*')
disp(' avg')
disp(avg)
disp(' SD:')
disp(SD)
disp(' corr')
disp(cor_)


[m n] = size(mutil);

mutil_ = [mutil(:,4) mutil(:,end)]; % x-x^* pdf
mutil_ = sortrows(mutil_,1);
max1= max(mutil_(:,1)); 
min1 = min(mutil_(:,1));
step1 = ( max1 - min1 ) / (nstep-1);

mutil_b = zeros(nstep,2);
for j=1:nstep
     ss1=0;
    mutil_b(j,1) = min1+(j+j-1)/2*step1;
 for i = 1:m
    if min1+(j-1)*step1<=mutil_(i,1) & mutil_(i,1) < min1+j*step1
        ss1 = ss1+mutil_(i,end);
    end
 end
       mutil_b(j,2) = ss1;
end
mutil_bench= mutil_b;

k=1;
for j =1:nstep
    if mutil_bench(j,2) > 0.00;
        zz_bench(k,:) = mutil_bench(j,:);
        k=k+1;
    end
end



%==========================================================
%   High Volatility Economy
%==========================================================

cd HighVolatility

load agrid.txt;
load dagrid.txt;
load cutoff_asset.txt;
load cutoff_xprod.txt;
load mu.txt;
load phi.txt;
load xgrid.txt;
load wage.txt

cd ..

xgrid=log(xgrid);
wage(:,2:end) =log(wage(:,2:end));

mu = mu(:,2:end)/10^10;
phi = phi(:,2)/10^10;
mu_a = sum(mu,2);
mu_x = sum(mu,1);

[na,nx] = size(mu);
mid_x = (nx+1)/2;

wages_conv = wage(:,2:end);
for i =1:nx
   wagepp(:,i) = spline(agrid, wages_conv(:,i));
end
for i=1:nx
    wage_(:,i) = ppval(wagepp(:,i), dagrid);
end

mutil = zeros(na,7);

k=1;
for i=1:na;
    a=dagrid(i);
    xj=cutoff_xprod(i);
    for j=xj:nx;
            xtil= xgrid(j) - xgrid(xj);
            wtil= wage_(i,j) - wage_(i,xj);
            mutil(k,1)=xtil;
            mutil(k,2)=xgrid(j);
            mutil(k,3)=xgrid(xj);
            mutil(k,4)=wtil;
            mutil(k,5)=wage_(i,j);
            mutil(k,6)=wage_(i,xj);
            mutil(k,7)=mu(i,j);
            k=k+1;
    end
end

ss=sum(mutil(:,end))

mutil(:,end) = mutil(:,end)/sum(mutil(:,end));
%mutilb=mutil;

[m n] = size(mutil);
for j=1:n-1
avg(j) = mutil(:,j)'*mutil(:,end);
SD(j) = ( (( mutil(:,j)-avg(j)).^2)'*mutil(:,end) )^.5;
end
for j=1:n-1
 for k=j:n-1
    cor_(j,k) = ( ( (mutil(:,j)-avg(j)).*(mutil(:,k)-avg(k)) )'*mutil(:,end) ) / ( SD(j)*SD(k) );
 end
end

disp('Benchmark')
disp('  ln x-ln x*    ln x    ln x*    ln w-ln w*    ln w    ln w*')
disp(' avg')
disp(avg)
disp(' SD:')
disp(SD)
disp(' corr')
disp(cor_)


[m n] = size(mutil);

mutil_ = [mutil(:,4) mutil(:,end)]; % x-x^* pdf
mutil_ = sortrows(mutil_,1);
max1= max(mutil_(:,1)); 
min1 = min(mutil_(:,1));
step1 = ( max1 - min1 ) / (nstep-1);

mutil_b = zeros(nstep,2);
for j=1:nstep
     ss1=0;
    mutil_b(j,1) = min1+(j+j-1)/2*step1;
 for i = 1:m
    if min1+(j-1)*step1<=mutil_(i,1) & mutil_(i,1) < min1+j*step1
        ss1 = ss1+mutil_(i,end);
    end
 end
       mutil_b(j,2) = ss1;
end
mutil_HV = mutil_b;

k=1;
for j =1:nstep
    if mutil_HV(j,2) > 0.00;
        zz_HV(k,:) = mutil_HV(j,:);
        k=k+1;
    end
end

cd ..\..\..\Matlab


%=============================================================
%   Figures 3 and 5 in the text
%=============================================================

figure(3)
plot(zz_bench(:,1), zz_bench(:,end),'bo-', 'linewidth',2);
xlabel('ln w - ln w* ','FontSize',12)
print Fig3 -depsc

figure(5)
plot(zz_HV(:,1), zz_HV(:,end), 'bo-', zz_bench(:,1), zz_bench(:,end),'ro:','linewidth',2);
legend('High-volatility Economy','Benchmark Economy')
xlabel('ln w - ln w*','FontSize',12)
print Fig5 -depsc
